import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UsaHash extends JFrame  {

    	Hash hash;

    	JLabel textoEntrada;
    	JTextField entrada;
	JLabel tamanhoVetor;
	JTextField tamVetor;
	JLabel lec1;
	JTextField leC1;
	JLabel lec2;
	JTextField leC2;

    	JButton botaoInsere;
	JButton botaoTamanho;

	int c1, c2;
    
    	JTextArea Saida;
   
    /** Inicia a classe UsaHash */
    public UsaHash() {
	   criaComponentes();
	   setVisible(true); 
    };


    /** Mostra o contedo da hash e colisoes */
    private void mostraHash() {
	   Saida.setText(hash.mostra());
	}


    /** Cria, posiciona e inicia os componentes da Interface
	    grfica, como caixas de textos e botes */
    private void criaComponentes() {

        /** Altera o texto na barra de ttulo da Janela. */
        setTitle("Programa Simples que Implementa uma tabela Hash (insercao Tentativa Quadrtica) ");

        /** Cria o texto que ser mostrado acima da caixa de entrada */
        textoEntrada = new JLabel("Entrada:");
	tamanhoVetor = new JLabel("Tamanho do vetor :");
	lec1 = new JLabel("C1 :");
	lec2 = new JLabel("C2 :");
		
	/** Cria as caixas de entrada para digitao dos elementos  */
	entrada = new JTextField(10);
	tamVetor = new JTextField(3);
	leC1 = new JTextField(4);
	leC2 = new JTextField(4);

        /** Cria o boto que ao ser clicado, insere novo elemento contido
		 na caixa de texto entrada. */
        botaoTamanho = new JButton();
        botaoTamanho.setText("OK");
        botaoTamanho.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
			
			    // Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto. 			
           	hash = new Hash(Integer.parseInt(tamVetor.getText()));
		c1 = Integer.parseInt(leC1.getText());
		c2 = Integer.parseInt(leC2.getText());
                mostraHash();
            }
        });

	/** Cria o boto que ao ser clicado, insere novo elemento contido
		 na caixa de texto entrada. */
        botaoInsere = new JButton();
        botaoInsere.setText("Insere");
        botaoInsere.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
			
			    // Aqui deve ser colocado o cdigo a ser executado quando
				// o usurio clicar no boto. 			
           	hash.insere(Integer.parseInt(entrada.getText()), c1, c2);
                mostraHash();
            }
        });


        /** Cria caixa de texto para mostrar o contedo da hash */
        Saida = new JTextArea(20,8);
	Saida.setLineWrap(true);


        /** Determina como os elementos grficos devem ser posicionados
		 na Janela.	 */
		 
		Container principal = getContentPane();
		principal.setLayout(new BoxLayout(principal,BoxLayout.Y_AXIS));
		
		JPanel tamanho = new JPanel();
		tamanho.setLayout(new BoxLayout(tamanho,BoxLayout.X_AXIS));
		tamanho.add(tamanhoVetor);
		tamanho.add(tamVetor);
		tamanho.add(lec1);
		tamanho.add(leC1);
		tamanho.add(lec2);
		tamanho.add(leC2);
		tamanho.add(botaoTamanho);

		JPanel entradaDados = new JPanel();
		entradaDados.setLayout(new BoxLayout(entradaDados,BoxLayout.X_AXIS));
		entradaDados.add(textoEntrada);
		entradaDados.add(entrada);	
		entradaDados.add(botaoInsere);
		
		principal.add(tamanho);
		principal.add(entradaDados);
		principal.add(Saida);


		/** Posicionamento da Janela na Tela do Computador. */
        setLocation(100,40);

        pack();

        /** Fecha o programa quando a janela  fechada. (Sem o cdigo abaixo,
		    a janela fecha mas o programa continua aberto - porm,s inacessvel) */	         addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                System.exit(0);
            }
        });
	}
		
    public static void main(String args[]) {
	    new UsaHash();
	}

}
